- Main Page
- Related Pages
- Modules
- Classes
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Friends

# MAttributePatternArray Class Reference

# OpenMaya - API module for common classes

Search for all occurrences

## Detailed Description

Indexable Array of attribute patterns.

Provides methods for manipulating arrays of attribute patterns.

Arrays of attribute patterns are used when constructing pattern lists from a string or file description. Since there's no way of knowing in advance how many will be created from a given description this general purpose array was needed.

The length of the array adjusts automatically.

`#include <MAttributePatternArray.h>`

List of all members.

## Public Member Functions
| MAttributePatternArray ()
| Class Constructor.
| MAttributePatternArray (const MAttributePatternArray &other)
| Copy Constructor.
| MAttributePatternArray (unsigned int initializeSize, const MAttributePattern &initialValue)
| Create a new array of MAttributePatterns of a specified size and initialize all the elements with the given initial value.
| ~MAttributePatternArray ()
| Class Destructor.
const MAttributePattern & | operator[] (unsigned int index) const
| Retrieves the read-only attribute pattern which is at the specified index in the array.
MAttributePatternArray & | operator= (const MAttributePatternArray &rhs)
| Assignment operator copies all of the elements of the other array into this one.
MStatus | set (const MAttributePattern &element, unsigned int index)
| Sets an element of the array to the given attribute pattern.
MStatus | setLength (unsigned int length)
| Set the length of the array.
unsigned int | length () const
| Determines the number of elements in the array.
MStatus | remove (unsigned int index)
| Removes the attribute pattern which is at the specified index in the array.
MStatus | insert (const MAttributePattern &element, unsigned int index)
| Inserts the given attribute pattern at the specified index in the array.
MStatus | append (const MAttributePattern &element)
| Appends the given attribute pattern to the end of the array.
MStatus | copy (const MAttributePatternArray &source)
| Copy the contents of the source array to this array.
MStatus | clear ()
| Clears this array.
void | setSizeIncrement (unsigned int newIncrement)
| Set the size by which the array will be expanded whenever expansion is necessary.
unsigned int | sizeIncrement () const
| Return the size by which the array will be expanded whenever expansion is necessary.
MAttributePattern & | operator[] (unsigned int index)
| Retrieves the attribute pattern which is at the specified index in the array.
## Static Public Member Functions
static const char * | className ()
| Returns the name of this class.
## Friends
OPENMAYA_EXPORT std::ostream & | operator<< (std::ostream &os, const MAttributePatternArray &array)
| NO SCRIPT SUPPORT.

## Constructor & Destructor Documentation

MAttributePatternArray | ( |  | ) |

Class Constructor.

Creates an attribute pattern Array

MAttributePatternArray | ( | const MAttributePatternArray & | other | ) |

Copy Constructor.

Parameters:

  [in] | other | the array with which to initialize this instance

MAttributePatternArray | ( | unsigned int | initialSize,
|  | const MAttributePattern & | initialValue
| ) |  |

Create a new array of MAttributePatterns of a specified size and initialize all the elements with the given initial value.

Parameters:

  [in] | initialSize | the initial size of the array
  [in] | initialValue | the initial value of each element

~MAttributePatternArray | ( |  | ) |

Class Destructor.

No additional action.

## Member Function Documentation

const MAttributePattern & operator[] | ( | unsigned int | index | ) | const

Retrieves the read-only attribute pattern which is at the specified index in the array.

Parameters:

  [in] | index | Zero-based index to the array

Returns:
  Attribute pattern at the specified index

MAttributePatternArray & operator= | ( | const MAttributePatternArray & | other | ) |

Assignment operator copies all of the elements of the other array into this one.

If the other array was returned as a reference to internal data then this array will also become a reference rather than doing a full copy.

Parameters:

  [in] | other | the array being copied

Returns:
  A reference to this array

MStatus set | ( | const MAttributePattern & | element,
|  | unsigned int | index
| ) |  |

Search for all occurrences

Sets an element of the array to the given attribute pattern.

Parameters:

  [in] | element | New attribute pattern to be set on the indicated element
  [in] | index | Zero-based index to the array

Returns:
  MS::kSuccess on success, otherwise MS::kFailure

MStatus setLength | ( | unsigned int | length | ) |

Search for all occurrences

Set the length of the array.

This will grow and shrink the array as desired. Elements that are grown have uninitialized values, while those which are shrunk will lose the data contained in the deleted elements (ie. it will release the memory).

Parameters:

  [in] | length | the new size of the array

unsigned int length | ( |  | ) | const

Search for all occurrences

Determines the number of elements in the array.

Returns:
  Number of elements in the array

MStatus remove | ( | unsigned int | index | ) |

Search for all occurrences

Removes the attribute pattern which is at the specified index in the array.

Parameters:

  [in] | index | Zero-based index to the array

Returns:
  MS::kSuccess on success, otherwise MS::kFailure

MStatus insert | ( | const MAttributePattern & | element,
|  | unsigned int | index
| ) |  |

Search for all occurrences

Inserts the given attribute pattern at the specified index in the array.

Parameters:

  [in] | element | attribute pattern to be inserted
  [in] | index | Zero-based index to the array

Returns:
  MS::kSuccess on success, otherwise MS::kFailure

MStatus append | ( | const MAttributePattern & | element | ) |

Search for all occurrences

Appends the given attribute pattern to the end of the array.

Parameters:

  [in] | element | attribute pattern to be appended

Returns:
  MS::kSuccess on success, otherwise MS::kFailure

MStatus copy | ( | const MAttributePatternArray & | source | ) |

Search for all occurrences

Copy the contents of the source array to this array.

Parameters:

  [in] | source | array to copy from

Returns:
  MS::kSuccess if the copy was successful and MS::kFailure otherwise

MStatus clear | ( |  | ) |

Search for all occurrences

Clears this array.

Length of the array becomes zero.

Returns:
  MS::kSuccess on success, otherwise MS::kFailure

void setSizeIncrement | ( | unsigned int | newIncrement | ) |

Search for all occurrences

Set the size by which the array will be expanded whenever expansion is necessary.

Parameters:

  [in] | newIncrement | the new increment

unsigned int sizeIncrement | ( |  | ) | const

Search for all occurrences

Return the size by which the array will be expanded whenever expansion is necessary.

Returns:
  The size increment.

MAttributePattern & operator[] | ( | unsigned int | index | ) |

Retrieves the attribute pattern which is at the specified index in the array.

Parameters:

  [in] | index | Zero-based index to the array

Returns:
  Attribute pattern at the specified index

const char * className | ( |  | ) | `[static]`

Search for all occurrences

Returns the name of this class.

Returns:
  The name of this class.

## Friends And Related Function Documentation

OPENMAYA_EXPORT std::ostream& operator<< | ( | std::ostream & | os,
|  | const MAttributePatternArray & | array
| ) |  | `[friend]`

NO SCRIPT SUPPORT.

The format used is [name, name, name, ... name].

Parameters:

  [in] | os | the ostream to print to
  [in] | array | the MAttributePatternArray whose value is to be printed

Returns:
  The ostream reference, s, provided as the first parameter.

MAttributePatternArray MAttributePatternArray MAttributePatternArray MAttributePatternArray MAttributePatternArray MAttributePatternArray MAttributePatternArray MAttributePatternArray MAttributePatternArray MAttributePatternArray
MAttributePatternArray MAttributePatternArray MAttributePatternArray MAttributePatternArray MAttributePatternArray MAttributePatternArray MAttributePatternArray MAttributePatternArray MAttributePatternArray MAttributePatternArray